mod Ex02

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Mxpr

incl Maux

loc rem 
  \para \bf  2. CVIČENIE Z PREDMETU 2-INF-264 TEÓRIA DEKLARATÍVNEHO 
  PROGRAMOVANIA  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end streda 30.9.2015 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-INF-264-tdp/1516zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované príkladu 
  algoritmicky vypočítateľnej funkcie, ktorá nie je primitívne rekurzívna 
  (univerzálna funkcia pre p.r. funkcie). Zadanie sa skladá z týchto 
  súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor \it  mxpr.cl  \end obsahuje aritmetizáciu p.r. 
         funkčných symbolov. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 5 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 2 
  \end
  \para Odovzdať do 4.10.2015 (nedeľa) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  Chapter. General Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion: Universal Function for 
  Primitive Recursive Functions.  \end 

rem 
  \para \bf  Primitive recursive function symbols.  \end 

rem 
  \para \bf  Arithmetization of primitive recursive function symbols.  \end See 
  also the module \it  Mxpr  \end. 

rem 
  \para \bf  Interpreter of primitive recursive function symbols. \it  (2 bonus 
  points)  \end  \end Define the interpreter of p.r. function symbols. 

fun/2 Interpreter 'Tex_f2_xpr_interpreter'
  Interpreter(e,x) = Foo

rem 
  \para \bf  Primitive recursive indices.  \end See also the binary predicate 
  \ft Prf(n,e) \end holding of well-formed p.r. indices defined in the module 
  \it  Mxpr  \end. 

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_1 'Tex_f0_xpr_xc1_1' \end Find a 
  well-formed p.r. index of the unary constant function \ft C1(x) = 1 \end, i.e. 
  find the number \ft Xc1_1 \end such that 
  \eq* 
    Prf(1,Xc1_1)
  \end
  \eq* 
    Interpreter(Xc1_1,x) = 1
  \end

fun/0 Xc1_1 'Tex_f0_xpr_xc1_1'
  Xc1_1 = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xc1_2 'Tex_f0_xpr_xc1_2' \end Find a 
  well-formed p.r. index of the unary constant function \ft C2(x) = 2 \end, i.e. 
  find the number \ft Xc1_2 \end such that 
  \eq* 
    Prf(1,Xc1_2)
  \end
  \eq* 
    Interpreter(Xc1_2,x) = 2
  \end

fun/0 Xc1_2 'Tex_f0_xpr_xc1_2'
  Xc1_2 = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/0 Xplus 'Tex_f0_xpr_xplus' \end Find a well-formed p.r. index of 
  the addition function \ft x+y \end, i.e. find the number \ft Xplus \end such 
  that 
  \eq* 
    Prf(2,Xplus)
  \end
  \eq* 
    Interpreter(Xplus,x,y) = x+y
  \end

fun/0 Xplus 'Tex_f0_xpr_xplus'
  Xplus = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xtimes 'Tex_f0_xpr_xtimes' \end Find 
  a well-formed p.r. index of the multiplication function \ft x*y \end, i.e. 
  find the number \ft Xtimes \end such that 
  \eq* 
    Prf(2,Xtimes)
  \end
  \eq* 
    Interpreter(Xtimes,x,y) = x*y
  \end

fun/0 Xtimes 'Tex_f0_xpr_xtimes'
  Xtimes = Foo

rem 
  \para \bf  Exercise. \it  (2 points)  \end  \end 
  \header* fun/0 Xexp 'Tex_f0_xpr_xexp' \end Find a well-formed p.r. index of 
  the exponentiation function \ft Exp(x,y) \end, i.e. find the number 
  \ft Xexp \end such that 
  \eq* 
    Prf(2,Xexp)
  \end
  \eq* 
    Interpreter(Xexp,x,y) = Exp(x,y)
  \end

fun/0 Xexp 'Tex_f0_xpr_xexp'
  Xexp = Foo

rem 
  \para \bf  Section. Exercises.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xsum 'Tex_f0_xpr_xsum' \end Find a 
  well-formed p.r. index of the summation function \ft Sum(n) \end, i.e. find 
  the number \ft Xsum \end such that 
  \eq* 
    Prf(1,Xsum)
  \end
  \eq* 
    Interpreter(Xsum,n) = Sum(n)
  \end

fun/0 Xsum 'Tex_f0_xpr_xsum'
  Xsum = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xfact 'Tex_f0_xpr_xfact' \end Find a 
  well-formed p.r. index of the factorial function \ft Fact(n) \end, i.e. find 
  the number \ft Xfact \end such that 
  \eq* 
    Prf(1,Xfact)
  \end
  \eq* 
    Interpreter(Xfact,n) = Fact(n)
  \end

fun/0 Xfact 'Tex_f0_xpr_xfact'
  Xfact = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xpred 'Tex_f0_xpr_xpred' \end Find a 
  well-formed p.r. index of the predecessor function \ft x-1 \end, i.e. find the 
  number \ft Xpred \end such that 
  \eq* 
    Prf(1,Xpred)
  \end
  \eq* 
    Interpreter(Xpred,x) = x-1
  \end

fun/0 Xpred 'Tex_f0_xpr_xpred'
  Xpred = Foo

rem 
  \para \bf  Exercise. \it  (2 points)  \end  \end 
  \header* fun/0 Xminus 'Tex_f0_xpr_xminus' \end Find a well-formed p.r. index 
  of the modified subtraction function \ft x-y \end, i.e. find the number 
  \ft Xminus \end such that 
  \eq* 
    Prf(2,Xminus)
  \end
  \eq* 
    Interpreter(Xminus,x,y) = x-y
  \end

fun/0 Xminus 'Tex_f0_xpr_xminus'
  Xminus = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

